#include "misc.hpp"

void die(const char *file, const char *func, const int line, const char *msg)
{
  cerr << "error in file " << string(file) << " function " << string(func);
  cerr << " line " << line << ": " << string(msg) << "... exiting" << endl;
  abort();
}

double EuclideanDistSqrd(double *x, double *y, int dim)
{
  double dist = 0;
  
  for(int i = 0; i < dim; i++)
    dist += (x[i] - y[i]) * (x[i] - y[i]);

  return dist;
}


double EuclideanDistSqrd(vector < double > &x, vector < double > &y)
{
  double dist = 0;
  
  for(int i = 0; i < x.size(); i++)
    dist += (x[i] - y[i]) * (x[i] - y[i]);

  return dist;
}

int hammingDist(vector < int > &x, vector < int > &y)
{
  int dist = 0;

  for(int i = 0; i < x.size(); i++)
    dist += x[i] == y[i] ? 0 : 1;

  return dist;
}

bool isEqual(vector < int > &x, vector < int > &y)
{
  if(x.size() != y.size()) return false;
  
  for(int i = 0; i < x.size(); i++)
    if(x[i] != y[i]) return false;
  
  return true;
}

bool isEqual(vector < double > &x, vector < double > &y, double e)
{
  if(x.size() != y.size()) return false;
  
  for(int i = 0; i < x.size(); i++)
    if(isEqual(x[i], y[i], e) == false) return false;
  
  return true;

}
