#ifndef MISC_H
#define MISC_H

#include <climits>
#include <cstdlib>
#include <string>
#include <iostream>
#include <cmath>
#include <vector>

using namespace std;

#define DEBUG "DEBUG"
#define STATS "STATS"
#define WEALT "WEALT"
#define PART1 "PART1"
#define PART2 "PART2"
#define PART3 "PART3"
#define BIDSM "BIDSM"
#define VECTS "VECTS"
#define PROGR "PROGR"
#define INITI "INITI"

#define EPSILON 1e-5

void die(const char*, const char *, const int, const char *);
double EuclideanDistSqrd(double *, double *, int);
double EuclideanDistSqrd(vector < double > &, vector < double > &);
int hammingDist(vector < int > &, vector < int > &);

inline bool isEqual(double x, double y) { return fabs(x - y) < EPSILON; }
inline bool isEqual(double x, double y, double e) { return fabs(x - y) < e; }

bool isEqual(vector < int > &, vector < int > &);
bool isEqual(vector < double > &, vector < double > &, double);

#endif
