#ifndef POP_H
#define POP_H

#include <vector>

#include "agent.hpp"

using namespace std;

class Pop
{
  
public:

  inline int size() { return _agents.size(); }

  inline vector < Agent * > :: iterator begin() { return _agents.begin(); }
  inline vector < Agent * > :: iterator end() { return _agents.end(); }

  inline Agent * removeLast() { Agent *a = _agents[_agents.size() - 1]; _agents.pop_back(); return a; }
  inline Agent * remove(int i) { Agent *a = _agents[i]; _agents.erase(_agents.begin() + i); return a; }
  inline vector < Agent * > :: iterator remove(vector < Agent * > :: iterator iter) { return _agents.erase(iter); }
  inline void pushBack(Agent *a) { _agents.push_back(a); }
  inline void clear() { _agents.clear(); }

  int actionCount(int); // Count how many agents have given action.
  
  void setActive(bool);
  
  Agent * operator[](int);
  
  vector < Agent * > _agents;
  
};

#endif
